// Voir README.md pour license précise, par Fcalva 2023-2024 et est sous GPLv3
// See README.md for the exact licensing, by ...

#pragma once

#include <libprof.h>
#include <gint/display.h>
#include "fixed.h"
#include "game.h"
#include "config.h"

typedef struct {

  prof_t raycast_time;
  prof_t draw_time;

} EngineTimers;

int get_pixel(bopti_image_t const *tex, int u, int v);

void dscale_bopti(bopti_image_t *tex, fixed_t scale_x, fixed_t scale_y,
                    int x, int y);

void draw_stripe(bopti_image_t *tex, int texSampleY, int linePos,
                  fixed_t texSize, int texX, int x);

void load_map();
void draw_walls(
#if debug
  EngineTimers *timers,
#endif
  RcGame *game
);
void move(RcGame *game);

