// Voir README.md pour license précise, par Fcalva 2023-2024 et est sous GPLv3
// See README.md for the exact licensing, by ...

#pragma once

#include <gint/display.h>

#include "utils.h"
#include "fixed.h"
#include "game.h"

//Adds the sprite reference to the internal sprite index
// /!\ This sprite reference may be used at every call of draw_sprites
void add_sprite(Sprite *sprite);

void clear_sprites();

int remove_sprite(Sprite *sprite);

void draw_sprites(bopti_image_t *tex_index[], RcActor *player);

//Returns distance (-1 if no hit), hit is set to the hit sprite
//or NULL if no hit (can be passed NULL) 
fixed_t raycast(RcGame *game, RcActor *origin, Sprite **hit); 
