//Par Fcalva et est sous GPLv3
#include <gint/display.h>
#include <gint/keyboard.h>
#include <gint/clock.h>

#include "C3D/fixed.h"
#include "C3D/game.h"
#include "C3D/sprites.h"
#include "C3D/moteur.h"
#include "C3D/map.h"
#include "C3D/config.h"

#include "gfx.h"

extern bopti_image_t briques0;
extern bopti_image_t buisson0;
extern bopti_image_t sprite_tst;
extern bopti_image_t sprite_tst1;
extern bopti_image_t bwain0;
extern bopti_image_t bwain1;
extern bopti_image_t meat0;
extern bopti_image_t meat1;
extern bopti_image_t anvil_pick;

bopti_image_t *tex_index[TINDEX_S] = {
  &briques0,   //0
  &buisson0,   //1
  &briques0,   //2
  &briques0,   //3
  &sprite_tst, //4
  &bwain0,     //5
  &meat0,      //6
  &anvil_pick  //7
};

int state = 0;
int anim_tex(GUNUSED RcGame *game){  
  tex_index[5] = state > 7 ? &bwain0:&bwain1;
  tex_index[6] = state > 7 ? &meat0:&meat1;
  tex_index[4] = state > 7 ? &sprite_tst:&sprite_tst1;
  state = (state+1) % 16;
  
  return 0;
}

void init_gfx(){
  add_logic_hook((RcLogicFunc*)&anim_tex);
}

extern bopti_image_t blood;

void death_anim(RcGame *game){
  for(int i = -23; i < DHEIGHT; i+=2){
    dimage(0,i,&blood);
    dupdate();
    sleep_us(10000);
  }
  dtext_opt(DWIDTH/2,DHEIGHT/2-20,0,C_NONE,DTEXT_CENTER,DTEXT_TOP,
              "Votre inconscient",-1);
  dtext_opt(DWIDTH/2,DHEIGHT/2-10,0,C_NONE,DTEXT_CENTER,DTEXT_TOP,
              "l'a emporte...",-1);
  dtext_opt(DWIDTH/2,DHEIGHT/2+10,0,C_NONE,DTEXT_CENTER,DTEXT_TOP,
              "[shift] recommencer",-1);
  dupdate();
  while(getkey_opt(0,NULL).key != KEY_SHIFT){}
}

extern bopti_image_t hands0;
extern bopti_image_t hands1;
extern bopti_image_t hands2;

extern bopti_image_t anvil0;
extern bopti_image_t anvil1;
extern bopti_image_t anvil2;
extern bopti_image_t anvil3;

WeapAnim weap_anims[WEAP_ANIM_C] = {
  {},
  {.frames = {&hands0, &hands1, &hands2, &hands1},
   .x = 15,
   .y = 42,
   .framec = 4,
   .frame_hit = 2
  },
  {.frames = {&anvil0, &anvil1, &anvil2, &anvil3, &anvil2, &anvil1},
   .x = 0,
   .y = 0,
   .framec = 6,
   .frame_hit = 3
  }
};

void draw_hands(CCGame *game){
  WeapAnim *anim = &weap_anims[game->curr_weapon];
  dimage(anim->x, anim->y, anim->frames[game->weapon_use/4]);
}

void draw_gui(CCGame *game){
  draw_hands(game);
  dline(100,0,100,63,3);
  dprint_opt(127,10,3,C_NONE,DTEXT_RIGHT,DTEXT_TOP,"%d",game->_bgame.player.hp);
  //TODO : replace w/ icon
  dtext_opt(127,20,3,C_NONE,DTEXT_RIGHT,DTEXT_TOP,"HP",-1);
}

